{ This is the input data - Xsize;  Ysize;  Stars map
20
15
* * *    * * *          * 
*   *     *      *   *  
*        *   *   *   *  
  * * *   *     * * *   * * *
    *               
*  *     * *   * * *      
*    *    *     *    * * *
   * *        * * *   *  
 *      *   *   *   * * * 
   * *  * *   * *      *  
              **    
 * * *   * * *   *       * 
*   *   *     *   *     *
   *   *     * * *      *
       *          * * *

                           
                         -------------------------
   (   10-     -  I)

         .     
  (   "*")    (    ). -
      1    .    -
 ,     , , ,    
      .     ,  
        ,   . 
     8   :  , , 
  90, 180  270,        -
    90, 180  270.       
      ,       
      ,   -  .-
       "*"   .   -
      100 x 100,    - 500, .
     - 160  .      -
 26 (       'a'..'z').

 :         :
   (1)     ( ReadData).
   (2)           
   ( FindAllSazv).
   (3)          -
          ( FindSimilars).
   (4)       ( PrintStarMap).
       K[],      .
          .  
      .  ,  ,  
     ,        (
    )    .   -
        .   
         .   -
      ,     .   -
            .  -
      ,      .
     FindAllSazv.     -  
 ,   X    Y     
    0           .
         ( Y  X -
 ).    ,         -
 .    ,          8-
  ,     ,   :
    -     ;
    -    ;
    -      .
    3   Similar     
 .       ,   -
            ,  
  8-         ,    
   ,     . 8-  
           -   
 90    .
           :
         'a'.      -
      .     ,
      .       -
            (  -
  - )   .      -
   .      .   
    ,   ,       -
        .       -
 .        -
   ,         
  .     .
}


CONST InFileName  = 'starry.pas';
      OutFileName = '';
      MaxSize     = 100;
      MaxSazvezdia= 500;
      MaxStars    = 160;
      aStar       = '*';
      aPoseten    = '';
      vUnexplored = ' ';


TYPE TPoint = record x,y:shortint; end;
     TCoords = array[1..MaxStars] of TPoint;
     TSazv = record
               StarsCount: integer;
               MaxX,MaxY: integer;
               Stars: TCoords;
               Value: char; {Similar 'Sazv' has equal 'value'}
               Xcoord,Ycoord: byte;
             end;


VAR K: array[1..MaxSize,1..MaxSize] of char;
    S: array[1..MaxSazvezdia] of ^TSazv;
    SizeX,SizeY: integer;
    SazvCount: integer;



Procedure ReadData;
{ Read the input data - SizeX;  SizeY;  Star Map (SizeX x SizeY) }
Var F: Text;
    x,y:integer;
    ch: char;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,SizeX); ReadLn(F,SizeY);
  for y:= 1 to SizeY do
    begin
      for x:= 1 to SizeX do
        Read(F,K[X,Y],ch);
      Read(F,ch); {ReadLn(F)}
    end;
  Close(F);
End;


Procedure MoveTo00(var S:TSazv);
{ Move the given sazvezdie to position (0,0) and sort its stars }

  Procedure QuickSort(var A: Tcoords; Lo,Hi: Integer);
    Procedure QSort(l,r: Integer);
    Var i,j: integer;
        x,tmp: TPoint;
    Begin
      i:= l; j:= r; x:= a[(l+r) div 2];
      repeat
        while (a[i].x < x.x) or ((a[i].x = x.x)and(a[i].y < x.y)) do
          i := i + 1;
        while (a[j].x > x.x) or ((a[j].x = x.x)and(a[j].y > x.y)) do
          j := j - 1;
        if i <= j then
          begin
            tmp:= a[i]; a[i]:= a[j]; a[j]:= tmp;
            i:= i + 1; j:= j - 1;
          end;
      until i > j;
      if l < j then QSort(l, j);
      if i < r then QSort(i, r);
    end;
  Begin
    QSort(Lo,Hi);
  End;

Var i,MinX,MinY: integer;
Begin
  MinX:=MaxInt; MinY:=MaxInt;
  with S do
    for i:= 1 to StarsCount do
      with Stars[i] do
        begin
          if x < MinX then MinX:=x;
          if y < MinY then MinY:=y;
        end;
  with S do
    for i:= 1 to StarsCount do
      with Stars[i] do
        begin
          x:= x - MinX;
          y:= y - MinY;
        end;
  QuickSort(S.Stars,1,S.StarsCount);
End;


Procedure FindSazvSizes(var S:TSazv);
{ Calculate the MaxX and MaxY coordinate of the given sazvezdie }
Var i: integer;
Begin
  S.MaxX:=-MaxInt; S.MaxY:=-MaxInt;
  with S do
    for i:= 1 to StarsCount do
      with Stars[i] do
        begin
          if x > MaxX then MaxX:=x;
          if y > MaxY then MaxY:=y;
        end;
End;


Procedure FindAllSazv;
{ Find all sazvedia from the star map. Every star is part of some sazvezdie }

  Procedure DFS(x,y:byte);
  Begin
    if (x < 1) or (x > SizeX) or (y > SizeY) or (y < 1) or
       (K[x,y] <> aStar) then Exit;
    K[x,y]:=aPoseten;
    with S[SazvCount]^ do
      begin Inc(StarsCount); Stars[StarsCount].x:=x; Stars[StarsCount].y:=y; end;
    DFS(x+1,y);   DFS(x-1,y);   DFS(x,y+1);   DFS(x,y-1);
    DFS(x-1,y-1); DFS(x+1,y-1); DFS(x-1,y+1); DFS(x+1,y+1);
  End;

Var x,y: integer;
Begin
  for Y:= 1 to SizeY do
    for X:= 1 to SizeX do
      if K[x,y] = aStar then
        begin
          Inc(SazvCount);
          New(s[SazvCount]);
          s[SazvCount]^.Xcoord:=x;
          s[SazvCount]^.Ycoord:=y;
          s[SazvCount]^.StarsCount:=0;
          s[SazvCount]^.Value:=vUnexplored;
          DFS(x,y); {Find the stars in current sazvezdie}
        end;
  for x:= 1 to SazvCount do
    MoveTo00(s[x]^);
  for x:= 1 to SazvCount do
    FindSazvSizes(s[x]^);
End;


Function Similar(a:TSazv; var b:TSazv): boolean;
{ Return if "a" and "b" are similar }

  Procedure CentrSimetria;
  Var i: integer;
  Begin
    with a do
      for i:= 1 to StarsCount do
        Stars[i].x:= MaxX - Stars[i].x;
  End;

  Function Equal: boolean; { Return true if a and b are completely equal }
  Var i: integer;
  Begin
    Equal:=false;
    MoveTo00(a);
    for i:= 1 to a.StarsCount do
      if (a.Stars[i].x <> b.Stars[i].x)
      or (a.Stars[i].y <> b.Stars[i].y) then
        Exit;
    Equal:=true;
  End;

  Procedure Rotate90; { Rotate the sazvezdie "a" at 90 }
  Var i,OldY: integer;
  Begin
    with a do
      for i:= 1 to StarsCount do
        with Stars[i] do
          begin
            OldY:=y;
            y:=x;
            x:= maxY-OldY;
          end;
    i:=a.MaxX; a.MaxX:=a.MaxY; a.MaxY:=i;
  End;

Begin
  if NOT (((a.MaxX=b.MaxX)and(a.MaxY=b.MaxY)) OR
          ((a.MaxX=b.MaxY)and(a.MaxY=b.MaxX))) then
    begin Similar:=false; Exit; end; {Different sizes --> not Similar}

  Similar:=true; if Equal then exit; {Try 0 equality}
  Rotate90; if Equal then exit;      {Try 90 equality}
  Rotate90; if Equal then exit;      {Try 180 equality}
  Rotate90; if Equal then exit;      {Try 270 equality}

  CentrSimetria; if Equal then exit; {Try symmetric 0 equality}
  Rotate90; if Equal then exit;      {Try symmetric 90 equality}
  Rotate90; if Equal then exit;      {Try symmetric 180 equality}
  Rotate90; if Equal then exit;      {Try symmetric 270 equality}

  Similar:=false; {Not equal in all possible 8 oriantations --> not Similar}
End;


Procedure FindSimilars;
{ Find all similar sazvezdia. Similar sazvezdia obtain equal letters
  in ".Value" field. Not similar obtain different letters than the other }
Var v: char;
    i,j: integer;
Begin
  v:=pred('a');
  for i:= 1 to SazvCount do
    if S[i]^.Value = vUnexplored then
      begin
        inc(v); S[i]^.Value:=v;
        for j:= i+1 to SazvCount do
          if Similar(S[i]^,S[j]^) then
            S[j]^.value:=v;
      end;
End;


Procedure PrintStarMap;
{ Create requested star map and print it in the output file }
Var v: char;
  Procedure DFS(x,y:byte);
  Begin { Fill current sazvezdie (x,y) with value v }
    if (x < 1) or (x > SizeX) or (y > SizeY) or (y < 1) or
       (K[x,y] <> aPoseten) then Exit;
    K[x,y]:=v;
    DFS(x+1,y);   DFS(x-1,y);   DFS(x,y+1);   DFS(x,y-1);
    DFS(x-1,y-1); DFS(x+1,y-1); DFS(x-1,y+1); DFS(x+1,y+1);
  End;
Var OutF: Text;
    i,x,y: integer;
Begin
  { Replace the stars on the map with their Value }
  for i:= 1 to SazvCount do
    with S[i]^ do
      begin
        v:=Value;
        DFS(Xcoord,Ycoord);
      end;
  { Print the map in the output file }
  Assign(OutF,OutFileName); ReWrite(OutF);
  for y:= 1 to SizeY do
    begin
      for x:= 1 to SizeX do
        Write(OutF,K[x,y],' ');
      WriteLn(OutF);
    end;
  WriteLn(OutF);
  Close(OutF);
End;


BEGIN
  ReadData;
  FindAllSazv;
  FindSimilars;
  PrintStarMap;
END.